/*
 *  Dot.cpp
 *  emptyExample
 *
 *  Created by Kate Watkins on 4/19/11.
 *  Copyright 2011 Parsons New School of Design. All rights reserved.
 *
 */
////\\\\////\\\\help via Andy Wallace////\\\\////\\\\//// 

#include "Dot.h"

void Dot::setup(int _section, int _col){

	section = _section;
	col = _col; 
	
	z = 0; 
	tileSize = 25; 
	
	// animate shape
	on = 0; 
	//tileHeight
	//tileWidth
	
	//length of rect
	width = 2; 
	
	//color Mix
	r2 = 0;
	g2 = 0; 
	b2 = 0; 
	
	alph = 255 + z * 5;
	
//\\//\\//\\ ROW 1 -- F-J-S-T-X-Z //\\//\\//\\//
// \\\//\\// F \\//\\//\\\//\\  
	
	if (section==0){
		row = 1; 
		r = 39;
		g =9;
		b = 50;
	}
//\\\//\\// J \\//\\//\\\//          	
	if (section==1){
		row = 2; 
		r = 50;
		g =16;
		b = 61;
	}
//\\\//\\// S \\//\\//\\\//           	
	if (section==2){
		row = 3; 
		r = 78;
		g =26;
		b = 82;
	}
//\\\//\\// T \\//\\//\\\//           	
	if (section==3){
		row = 4; 
		r = 97;
		g =32;
		b = 94;
	}
//\\\//\\// X \\//\\//\\\//           	
	if (section==4){
		row = 5; 
		r = 110;
		g =41;
		b = 83;
	}
//\\\//\\// Z \\//\\//\\\//           	
	if (section==5){
		row = 6; 
		r = 130;
		g =50;
		b = 75;
	}
//\\//\\//\\ ROW 2 -- C-H-K-Q //\\//\\//\\//
// \\\//\\// C \\//\\//\\\//  	
    if (section==6){
		row = 7; 
		r = 39; 
		g = 64;
		b = 139;
	}
//\\\//\\// H \\//\\//\\\//  	
    if (section==7){
		row = 8; 
		r = 61; 
		g =  89;
		b = 171;
	}
//\\\//\\// K \\//\\//\\\//  	
    if (section==8){
		row = 9; 
		r = 76; 
		g =  108;
		b = 205;
	}
//\\\//\\// Q \\//\\//\\\//  	
    if (section==9){
		row = 10; 
		r = 112; 
		g =  136;
		b = 204;
	}
//\\//\\//\\ ROW 3 //\\//\\//\\//
//\\//\\//\\ X //\\//\\//\\//	
		if(section==10){
		row=11;
		r=202;
		g=218;
		b=241; 
	}
//\\//\\//\\ ROW 4 //\\//\\//\\//	
// A \\//
	if(section==11){
		row=12;
		r=54;
		g=191;
		b=162; 
	}
// E \\//
	if(section==12){
		row=13;
		r=90;
		g=204;
		b=170; 
	}
// I \\//
	if(section==13){
		row=14;
		r=136;
		g=217;
		b=183; 
	}
// O \\//
	if(section==14){
		row=15;
		r=187;
		g=229;
		b=202; 
	}
// U \\//
	if(section==15){
		row=16;
		r=229;
		g=242;
		b=226; 
	}
//\\//\\//\\ ROW 5 //\\//\\//\\//	
//\\//\\// D-G-Y \\//\\//\\//	
//\\//\\// D \\//\\//\\//
	if(section==16){
		row=17;
		r=255;
		g=210;
		b=132; 
	}
//\\//\\// G \\//\\//\\//
	if(section==17){
		row=18;
		r=255;
		g=194;
		b=88; 
	}
//\\//\\// Y \\//\\//\\//
	if(section==18){
		row=19;
		r=228;
		g=246;
		b=173; 
	}
//\\//\\//\\ ROW 6 //\\//\\//\\//	
//\\//\\// B-P-R-W \\//\\//\\//	
//\\//\\// B \\//\\//\\//	
	if(section==19){
		row=20;
		r=61;
		g=127;
		b=127;
	}
//\\//\\// P \\//\\//\\//	
	if(section==20){
		row=21;
		r=98;
		g=130;
		b=130;
	}
//\\//\\// R \\//\\//\\//	
	if(section==21){
		row=22;
		r=133;
		g=131;
		b=131; 
	}
//\\//\\// W \\//\\//\\//	
	if(section==22){
		row=23;
		r=163;
		g=130;
		b=130; 
	}
//\\//\\//\\ ROW 7 //\\//\\//\\//	
//\\//\\// L-M-N \\//\\//\\//
//\\//\\// L \\//\\//\\//
	if(section==23){
		row=24;
		r=194;
		g=130;
		b=130; 
	}	
//\\//\\// M \\//\\//\\//
	if(section==24){
		row=25;
		r=255;
		g=119;
		b=119; 
	}	
//\\//\\// N \\//\\//\\//
	if(section==25){
		row=26;
		r=255;
		g=174;
		b=174; 
	}	
}
//----------------------------------------------------------------------------------------------------------------------------
void Dot::update(){
	
}
//----------------------------------------------------------------------------------------------------------------------------
void Dot::draw(){
	ofEnableAlphaBlending();
	
	//decrease alpha value with z-axis
	int alph = 255 + z * 4; 
    int animate = tileSize + on; 
	
	
	float redMix = r  + r2;
	float greenMix = g + g2;
	float blueMix = b + b2;
	
	ofSetColor(redMix,greenMix, blueMix, alph); 
	
	
	ofPushMatrix(); 
	ofTranslate( col * tileSize, row * tileSize, z * tileSize); 
	//ofRect(0,0, width*tileSize/2, tileSize/2);
	ofRect(0,0, width*tileSize/2 + animate/2, tileSize/2 + animate/2); 
    ofPopMatrix();
	
	/* original
	ofPushMatrix(); 
	ofTranslate( col * tileSize, row * tileSize, z * tileSize); 
	ofRect(0,0, width*tileSize/2, tileSize/2); 
    ofPopMatrix();
	*/	
		
}
//----------------------------------------------------------------------------------------------------------------------------
void Dot::moveBack(){
	
	z-=4; 
	
}
//----------------------------------------------------------------------------------------------------------------------------
void Dot::moveForward(){
	
	z+=4; 
	
}

//----------------------------------------------------------------------------------------------------------------------------
void Dot::growBig(){
	
	//int alph = 255 + z * 5; 
	on+=40; 
	
	r2+=50;
	g2+=50;
	b2+=50; 
	
	//ofSetColor(redMix, greenMix, blueMix, alph); 
	
}

//----------------------------------------------------------------------------------------------------------------------------
void Dot:: shrinkSmall(){
	//int alph = 255 + z * 5;
	on=0; 
	
	r2=0;
	g2=0;
	b2=0;

	
	
}






