#include "testApp.h"
//--------------------------------------------------------------
void testApp::setup(){
	ofSetFrameRate(80);
	ofEnableAlphaBlending();
	ofBackground(255,255,255); 
	count = 0; 
	int gridHeight = 100;
	int gridWidth = 100; 
	//bool noDot=false;	//assume we will make a dot
	//int section=0;	
	// open an outgoing connection to HOST:PORT
	sender.setup( HOST, PORT );
}
//--------------------------------------------------------------
void testApp::update(){
	ofEnableAlphaBlending();
	for(int i = 0; i < dots.size(); i++){ 
		dots[i].update(); 
	}
}
//--------------------------------------------------------------
void testApp::draw(){
	ofEnableAlphaBlending();
	for(int i = 0; i < dots.size(); i++){ 
		dots[i].draw(); 
	}
}
//--------------------------------------------------------------
void testApp::keyPressed(int key){
	cout<<key<<endl;
	bool noDot=false;	//assume we will make a dot
	int section=0;	
//	if (key=='a'){
//		cout<<"hi"<<endl;
//	}
// test -- using of_key_right & right (typewriter)	---///--\\\--  Z AXIS TEST
//Z-AXIS	//\\\\\////this works//\\\//
	if(key== OF_KEY_DEL){
		
		for( int i=0; i < dots.size(); i++){
			dots[i].moveBack(); 
		}
		count=0; 
		
		noDot=true;
	}

//\\///\\\///\\\///\\--------/\----/\----------------//
//\\///\\\///\\\///\\-----/\//\\--//\\--------------//
//\\//define keys//\\///\\\///\\\///\\\-TYPEWRITER-// 
//\\\\----------//\\--//\\--//\\--//-\\\----------//
//\\//ROW 0//\\///\\\///\\\///\\\// 
	
	ofxOscMessage m;
	m.setAddress( "/key");
	
	if(key == 'f'){
		section=0; 
		m.addIntArg(83);
		m.addIntArg(47);
	}
	if(key == 'j'){
		section=1;
		m.addIntArg(81);
		m.addIntArg(47);
	}
	if(key == 's'){
		section=2; 
		m.addIntArg(79);
		m.addIntArg(47);
	}
	if(key == 't'){
		section=3; 
		m.addIntArg(76);
		m.addIntArg(47);
	}
	if(key == 'x'){
		section=4; 
		m.addIntArg(74);
		m.addIntArg(47);
	}
	if(key == 'z'){
		section=5; 
		m.addIntArg(72);
		m.addIntArg(47);
	}
	
//\\//ROW 1 - c-h-k-q //\\///\\\///\\\///\\\// 
	
	if(key == 'c'){
		section=6;
		m.addIntArg(70);
		m.addIntArg(47);
	}
	if(key == 'h'){
		section=7;
		m.addIntArg(68);
		m.addIntArg(47);
	}
	if(key == 'k'){
		section=8;
		m.addIntArg(67);
		m.addIntArg(47);
	}
	if(key == 'q'){
		section=9;
		m.addIntArg(66);
		m.addIntArg(47);
	}
	
//\\//ROW 2 - v //\\///\\\///\\\///\\\//	
	
	if(key == 'v'){
		section=10;
		m.addIntArg(65);
		m.addIntArg(47);
	}
//\\//ROW 3 - a-e-i-o-u //\\///\\\///\\\///\\\//	
	
	if(key == 'a'){
		section=11;
		m.addIntArg(61);
		m.addIntArg(47);
	}
	if(key == 'e'){
		section=12;
		m.addIntArg(60);
		m.addIntArg(47);
	}
	if(key == 'i'){
		section=13;
		m.addIntArg(59);
		m.addIntArg(47);
	}
	if(key == 'o'){
		section=14;
		m.addIntArg(58);
		m.addIntArg(47);
	}
	if(key == 'u'){
		section=15;
		m.addIntArg(57);
		m.addIntArg(47);
	}
	
//ROW 4 - d-g-b //\\///\\\///\\\///\\\//
	if(key == 'd'){
		section=16; 
		m.addIntArg(54);
		m.addIntArg(47);
	}
	if(key == 'g'){
		section=17; 
		m.addIntArg(52);
		m.addIntArg(47);
	}
	if(key == 'y'){
		section=18; 
		m.addIntArg(50);
		m.addIntArg(47);
	}
//ROW 5 - b-p-r-w //\\///\\\///\\\///\\\//
	if(key == 'b'){
		section=19; 
		m.addIntArg(49);
		m.addIntArg(47);
	}
	if(key == 'p'){
		section=20; 
		m.addIntArg(47);
		m.addIntArg(47);
	}
	if(key == 'r'){
		section=21; 
		m.addIntArg(45);
		m.addIntArg(47);
	}
	if(key == 'w'){
		section=22; 
		m.addIntArg(44);
		m.addIntArg(47);
	}
//\\//ROW 6 - l-m-n //\\///\\\///\\\///\\\//
	if(key == 'l'){
		section=23;
		m.addIntArg(42);
		m.addIntArg(47);
	}
	if(key == 'm'){
		section=24; 
		m.addIntArg(39);
		m.addIntArg(47);
	}
	if(key == 'n'){
		section=25; 
		m.addIntArg(37);
		m.addIntArg(47);
	}
//\\//\\//\\///\\\///\\\\/////\\\\\////\\\///\\\////\\\///\\\///\\\///\\\\\\\\\\//////////////\\\\\\\\\\//
//SUSPENSION OF NOTE//\\//\\//
	//of_key_left -- 'SHIFT'
	if(key==OF_KEY_LEFT){
		dots[dots.size()-1].width = 13; 
		noDot=true;
		ofxOscMessage g;
		g.setAddress( "/sustain");
		g.addIntArg(6000);
		sender.sendMessage(g);
		//increase duration
	}		
//\\//\\ pause note//sound //\\//\\//\\//  
	//32=SPACE; 
	//if(key==32){  //of_key_right -- 
	if(key==OF_KEY_BACKSPACE){
		dots[dots.size()-1].width = 7; 
		noDot=true;
		ofxOscMessage g;
		g.setAddress( "/sustain");
		g.addIntArg(1);
		sender.sendMessage(g);
		//no sound
		
	}
	if (noDot==false){
	Dot myDot;
		myDot.setup(section, count);  
		dots.push_back(myDot); 
	    count ++; 
	//pulse all of the dots of the same type
		for( int i=0; i < dots.size(); i++){
			if(dots[i].section==section){
				dots[i].growBig();
			}
		}
	}
	
	if(count >= 40){
		count = 0;
	}
	
	sender.sendMessage( m );
}
//--------------------------------------------------------------
void testApp::keyReleased(int key){
	bool noDot=false;	//assume we will make a dot
	int section=0;	
	
	////suspension of note // 
	if(key == OF_KEY_LEFT){
		ofxOscMessage g;
		g.setAddress( "/sustain");
		g.addIntArg(80);
		sender.sendMessage(g);
		//increase duration
	}
	
//	SPACE// pause key/\/\/\\/\/\\//////
	////////TEST
	if(key==OF_KEY_BACKSPACE){
		ofxOscMessage g;
		g.setAddress( "/sustain");
		g.addIntArg(80);
		sender.sendMessage(g);
		//no sound
		}
	
	if(key =='a'|| key =='b'|| key =='c'|| key =='d'|| key =='e'|| key =='f'|| key =='g'|| key =='h'|| key =='i'|| key =='j'|| key =='k'|| key =='l'|| key =='m'|| key =='n'|| key =='o'|| key =='p'|| key =='q'|| key =='r'||key =='s'|| key =='t'|| key =='u'|| key =='v'|| key =='w'|| key =='x'|| key =='y'|| key =='z'){
		for( int i=0; i < dots.size(); i++){
			dots[i].shrinkSmall(); 
		}
	}
}
//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}
//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
}
//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
}
//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
}
//--------------------------------------------------------------
void testApp::windowResized(int w, int h){
}
