#ifndef _TEST_APP
#define _TEST_APP


#include "ofMain.h"
#include "Dot.h"
#define OF_ADDON_USING_OFXOSC
#include "ofAddons.h"
#define HOST "localhost"
#define PORT 12000

class testApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();

		void keyPressed  (int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);

	
	vector <Dot> dots;
	
	int count;
	
	
	//variables : height and width of grid
	int gridHeight;
	int gridWidth;
	
private:
	
	ofxOscSender sender;
	
	
};

#endif
